wxWidgets: wxTreeCtrl Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxTreeCtrl Class Reference
Controls

`#include <wx/treectrl.h>`

Inheritance diagram for wxTreeCtrl:
[legend]

## Detailed Description

A tree control presents information as a hierarchy, with items that may be expanded to show further items.

Items in a tree control are referenced by wxTreeItemId handles, which may be tested for validity by calling wxTreeItemId::IsOk().

A similar control with a fully native implementation for GTK+ and OS X as well is wxDataViewTreeCtrl.

To intercept events from a tree control, use the event table macros described in wxTreeEvent.

## Styles

This class supports the following styles:

- wxTR_EDIT_LABELS:
  Use this style if you wish the user to be able to edit labels in the tree control.
- wxTR_NO_BUTTONS:
  For convenience to document that no buttons are to be drawn.
- wxTR_HAS_BUTTONS:
  Use this style to show + and - buttons to the left of parent items.
- wxTR_TWIST_BUTTONS:
  Selects alternative style of `+/`-` buttons` and shows rotating ("twisting") arrows instead. Currently this style is only implemented under Microsoft Windows Vista and later Windows versions and is ignored under the other platforms. Notice that under Vista this style results in the same appearance as used by the tree control in Explorer and other built-in programs and so using it may be preferable to the default style.
- wxTR_NO_LINES:
  Use this style to hide vertical level connectors.
- wxTR_FULL_ROW_HIGHLIGHT:
  Use this style to have the background colour and the selection highlight extend over the entire horizontal row of the tree control window. (This flag is ignored under Windows unless you specify `wxTR_NO_LINES` as well.)
- wxTR_LINES_AT_ROOT:
  Use this style to show lines between root nodes. Only applicable if `wxTR_HIDE_ROOT` is set and `wxTR_NO_LINES` is not set.
- wxTR_HIDE_ROOT:
  Use this style to suppress the display of the root node, effectively causing the first-level nodes to appear as a series of root nodes.
- wxTR_ROW_LINES:
  Use this style to draw a contrasting border between displayed rows.
- wxTR_HAS_VARIABLE_ROW_HEIGHT:
  Use this style to cause row heights to be just big enough to fit the content. If not set, all rows use the largest row height. The default is that this flag is unset. Generic only.
- wxTR_SINGLE:
  For convenience to document that only one item may be selected at a time. Selecting another item causes the current selection, if any, to be deselected. This is the default.
- wxTR_MULTIPLE:
  Use this style to allow a range of items to be selected. If a second range is selected, the current range, if any, is deselected.
- wxTR_DEFAULT_STYLE:
  The set of flags that are closest to the defaults for the native control for a particular toolkit.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTreeEvent& event)

Event macros for events emitted by this class:

- EVT_TREE_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button. If you want to enable left-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Processes a `wxEVT_TREE_BEGIN_DRAG` event type.
- EVT_TREE_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button. If you want to enable right-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Processes a `wxEVT_TREE_BEGIN_RDRAG` event type.
- EVT_TREE_END_DRAG(id, func):
  End dragging with the left or right mouse button. Processes a `wxEVT_TREE_END_DRAG` event type.
- EVT_TREE_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_TREE_BEGIN_LABEL_EDIT` event type.
- EVT_TREE_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_TREE_END_LABEL_EDIT` event type.
- EVT_TREE_DELETE_ITEM(id, func):
  An item was deleted. Processes a `wxEVT_TREE_DELETE_ITEM` event type.
- EVT_TREE_GET_INFO(id, func):
  Request information from the application. Processes a `wxEVT_TREE_GET_INFO` event type.
- EVT_TREE_SET_INFO(id, func):
  Information is being supplied. Processes a `wxEVT_TREE_SET_INFO` event type.
- EVT_TREE_ITEM_ACTIVATED(id, func):
  The item has been activated, i.e. chosen by double clicking it with mouse or from keyboard. Processes a `wxEVT_TREE_ITEM_ACTIVATED` event type.
- EVT_TREE_ITEM_COLLAPSED(id, func):
  The item has been collapsed. Processes a `wxEVT_TREE_ITEM_COLLAPSED` event type.
- EVT_TREE_ITEM_COLLAPSING(id, func):
  The item is being collapsed. This can be prevented by calling Veto(). Processes a `wxEVT_TREE_ITEM_COLLAPSING` event type.
- EVT_TREE_ITEM_EXPANDED(id, func):
  The item has been expanded. Processes a `wxEVT_TREE_ITEM_EXPANDED` event type.
- EVT_TREE_ITEM_EXPANDING(id, func):
  The item is being expanded. This can be prevented by calling Veto(). Processes a `wxEVT_TREE_ITEM_EXPANDING` event type.
- EVT_TREE_ITEM_RIGHT_CLICK(id, func):
  The user has clicked the item with the right mouse button. Processes a `wxEVT_TREE_ITEM_RIGHT_CLICK` event type.
- EVT_TREE_ITEM_MIDDLE_CLICK(id, func):
  The user has clicked the item with the middle mouse button. This is only supported by the generic control. Processes a `wxEVT_TREE_ITEM_MIDDLE_CLICK` event type.
- EVT_TREE_SEL_CHANGED(id, func):
  Selection has changed. Processes a `wxEVT_TREE_SEL_CHANGED` event type.
- EVT_TREE_SEL_CHANGING(id, func):
  Selection is changing. This can be prevented by calling Veto(). Processes a `wxEVT_TREE_SEL_CHANGING` event type.
- EVT_TREE_KEY_DOWN(id, func):
  A key has been pressed. Processes a `wxEVT_TREE_KEY_DOWN` event type.
- EVT_TREE_ITEM_GETTOOLTIP(id, func):
  The opportunity to set the item tooltip is being given to the application (call wxTreeEvent::SetToolTip). Windows only. Processes a `wxEVT_TREE_ITEM_GETTOOLTIP` event type.
- EVT_TREE_ITEM_MENU(id, func):
  The context menu for the selected item has been requested, either by a right click or by using the menu key. Processes a `wxEVT_TREE_ITEM_MENU` event type.
- EVT_TREE_STATE_IMAGE_CLICK(id, func):
  The state image has been clicked. Processes a `wxEVT_TREE_STATE_IMAGE_CLICK` event type.

See also Window Styles.

Win32 notes:

wxTreeCtrl class uses the standard common treeview control under Win32 implemented in the system library comctl32.dll. Some versions of this library are known to have bugs with handling the tree control colours: the usual symptom is that the expanded items leave black (or otherwise incorrectly coloured) background behind them, especially for the controls using non-default background colour. The recommended solution is to upgrade the comctl32.dll to a newer version: see http://www.microsoft.com/downloads/details.aspx?familyid=cb2cf3a2-8025-4e8f-8511-9b476a8d35d2

##

Library: wxCore
Category: Controls
Appearance:

wxMSW Appearance | wxGTK Appearance | wxOSX Appearance

See Also
  wxDataViewTreeCtrl, wxTreeEvent, wxTreeItemData, wxTreeCtrl Overview, wxListBox, wxListCtrl, wxImageList

## Public Member Functions
| wxTreeCtrl ()
| Default Constructor.
| wxTreeCtrl (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTR_DEFAULT_STYLE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTreeCtrlNameStr)
| Constructor, creating and showing a tree control.
virtual | ~wxTreeCtrl ()
| Destructor, destroying the tree control.
virtual wxTreeItemId | AddRoot (const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Adds the root node to the tree, returning the new item.
wxTreeItemId | AppendItem (const wxTreeItemId &parent, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Appends an item to the end of the branch identified by parent, return a new item id.
void | AssignButtonsImageList (wxImageList *imageList)
| Sets the buttons image list.
void | AssignImageList (wxImageList *imageList)
| Sets the normal image list.
void | AssignStateImageList (wxImageList *imageList)
| Sets the state image list.
virtual void | Collapse (const wxTreeItemId &item)
| Collapses the given item.
void | CollapseAll ()
| Collapses the root item.
void | CollapseAllChildren (const wxTreeItemId &item)
| Collapses this item and all of its children, recursively.
virtual void | CollapseAndReset (const wxTreeItemId &item)
| Collapses the given item and removes all children.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTR_DEFAULT_STYLE, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxTreeCtrlNameStr)
| Creates the tree control.
virtual void | Delete (const wxTreeItemId &item)
| Deletes the specified item.
virtual void | DeleteAllItems ()
| Deletes all items in the control.
virtual void | DeleteChildren (const wxTreeItemId &item)
| Deletes all children of the given item (but not the item itself).
virtual wxTextCtrl * | EditLabel (const wxTreeItemId &item, wxClassInfo *textCtrlClass=wxCLASSINFO(wxTextCtrl))
| Starts editing the label of the given item.
void | EnableBellOnNoMatch (bool on=true)
| Enable or disable a beep if there is no match for the currently entered text when searching for the item from keyboard.
virtual void | EndEditLabel (const wxTreeItemId &item, bool discardChanges=false)
| Ends label editing.
virtual void | EnsureVisible (const wxTreeItemId &item)
| Scrolls and/or expands items to ensure that the given item is visible.
virtual void | Expand (const wxTreeItemId &item)
| Expands the given item.
void | ExpandAll ()
| Expands all items in the tree.
void | ExpandAllChildren (const wxTreeItemId &item)
| Expands the given item and all its children recursively.
virtual bool | GetBoundingRect (const wxTreeItemId &item, wxRect &rect, bool textOnly=false) const
| Retrieves the rectangle bounding the item.
wxImageList * | GetButtonsImageList () const
| Returns the buttons image list (from which application-defined button images are taken).
virtual size_t | GetChildrenCount (const wxTreeItemId &item, bool recursively=true) const
| Returns the number of items in the branch.
virtual unsigned int | GetCount () const
| Returns the number of items in the control.
virtual wxTextCtrl * | GetEditControl () const
| Returns the edit control being currently used to edit a label.
virtual wxTreeItemId | GetFirstChild (const wxTreeItemId &item, wxTreeItemIdValue &cookie) const
| Returns the first child; call GetNextChild() for the next child.
virtual wxTreeItemId | GetFirstVisibleItem () const
| Returns the first visible item.
virtual wxTreeItemId | GetFocusedItem () const
| Returns the item last clicked or otherwise selected.
virtual void | ClearFocusedItem ()
| Clears the currently focused item.
virtual void | SetFocusedItem (const wxTreeItemId &item)
| Sets the currently focused item.
wxImageList * | GetImageList () const
| Returns the normal image list.
virtual unsigned int | GetIndent () const
| Returns the current tree control indentation.
virtual wxColour | GetItemBackgroundColour (const wxTreeItemId &item) const
| Returns the background colour of the item.
virtual wxTreeItemData * | GetItemData (const wxTreeItemId &item) const
| Returns the tree item data associated with the item.
virtual wxFont | GetItemFont (const wxTreeItemId &item) const
| Returns the font of the item label.
virtual int | GetItemImage (const wxTreeItemId &item, wxTreeItemIcon which=wxTreeItemIcon_Normal) const
| Gets the specified item image.
virtual wxTreeItemId | GetItemParent (const wxTreeItemId &item) const
| Returns the item's parent.
int | GetItemState (const wxTreeItemId &item) const
| Gets the specified item state.
virtual wxString | GetItemText (const wxTreeItemId &item) const
| Returns the item label.
virtual wxColour | GetItemTextColour (const wxTreeItemId &item) const
| Returns the colour of the item label.
virtual wxTreeItemId | GetLastChild (const wxTreeItemId &item) const
| Returns the last child of the item (or an invalid tree item if this item has no children).
virtual wxTreeItemId | GetNextChild (const wxTreeItemId &item, wxTreeItemIdValue &cookie) const
| Returns the next child; call GetFirstChild() for the first child.
virtual wxTreeItemId | GetNextSibling (const wxTreeItemId &item) const
| Returns the next sibling of the specified item; call GetPrevSibling() for the previous sibling.
virtual wxTreeItemId | GetNextVisible (const wxTreeItemId &item) const
| Returns the next visible item or an invalid item if this item is the last visible one.
virtual wxTreeItemId | GetPrevSibling (const wxTreeItemId &item) const
| Returns the previous sibling of the specified item; call GetNextSibling() for the next sibling.
virtual wxTreeItemId | GetPrevVisible (const wxTreeItemId &item) const
| Returns the previous visible item or an invalid item if this item is the first visible one.
bool | GetQuickBestSize () const
| Returns true if the control will use a quick calculation for the best size, looking only at the first and last items.
virtual wxTreeItemId | GetRootItem () const
| Returns the root item for the tree control.
virtual wxTreeItemId | GetSelection () const
| Returns the selection, or an invalid item if there is no selection.
virtual size_t | GetSelections (wxArrayTreeItemIds &selection) const
| Fills the array of tree items passed in with the currently selected items.
wxImageList * | GetStateImageList () const
| Returns the state image list (from which application-defined state images are taken).
wxTreeItemId | HitTest (const wxPoint &point, int &flags) const
| Calculates which (if any) item is under the given point, returning the tree item id at this point plus extra information flags.
wxTreeItemId | InsertItem (const wxTreeItemId &parent, const wxTreeItemId &previous, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Inserts an item after a given one (previous).
wxTreeItemId | InsertItem (const wxTreeItemId &parent, size_t pos, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Inserts an item before one identified by its position (pos).
virtual bool | IsBold (const wxTreeItemId &item) const
| Returns true if the given item is in bold state.
bool | IsEmpty () const
| Returns true if the control is empty (i.e. has no items, even no root one).
virtual bool | IsExpanded (const wxTreeItemId &item) const
| Returns true if the item is expanded (only makes sense if it has children).
virtual bool | IsSelected (const wxTreeItemId &item) const
| Returns true if the item is selected.
virtual bool | IsVisible (const wxTreeItemId &item) const
| Returns true if the item is visible on the screen.
virtual bool | ItemHasChildren (const wxTreeItemId &item) const
| Returns true if the item has children.
virtual int | OnCompareItems (const wxTreeItemId &item1, const wxTreeItemId &item2)
| Override this function in the derived class to change the sort order of the items in the tree control.
wxTreeItemId | PrependItem (const wxTreeItemId &parent, const wxString &text, int image=-1, int selImage=-1, wxTreeItemData *data=NULL)
| Appends an item as the first child of parent, return a new item id.
virtual void | ScrollTo (const wxTreeItemId &item)
| Scrolls the specified item into view.
virtual void | SelectItem (const wxTreeItemId &item, bool select=true)
| Selects the given item.
void | SetButtonsImageList (wxImageList *imageList)
| Sets the buttons image list (from which application-defined button images are taken).
virtual void | SetImageList (wxImageList *imageList)
| Sets the normal image list.
virtual void | SetIndent (unsigned int indent)
| Sets the indentation for the tree control.
virtual void | SetItemBackgroundColour (const wxTreeItemId &item, const wxColour &col)
| Sets the colour of the item's background.
virtual void | SetItemBold (const wxTreeItemId &item, bool bold=true)
| Makes item appear in bold font if bold parameter is true or resets it to the normal state.
virtual void | SetItemData (const wxTreeItemId &item, wxTreeItemData *data)
| Sets the item client data.
virtual void | SetItemDropHighlight (const wxTreeItemId &item, bool highlight=true)
| Gives the item the visual feedback for Drag'n'Drop actions, which is useful if something is dragged from the outside onto the tree control (as opposed to a DnD operation within the tree control, which already is implemented internally).
virtual void | SetItemFont (const wxTreeItemId &item, const wxFont &font)
| Sets the item's font.
virtual void | SetItemHasChildren (const wxTreeItemId &item, bool hasChildren=true)
| Force appearance of the button next to the item.
virtual void | SetItemImage (const wxTreeItemId &item, int image, wxTreeItemIcon which=wxTreeItemIcon_Normal)
| Sets the specified item's image.
void | SetItemState (const wxTreeItemId &item, int state)
| Sets the specified item state.
virtual void | SetItemText (const wxTreeItemId &item, const wxString &text)
| Sets the item label.
virtual void | SetItemTextColour (const wxTreeItemId &item, const wxColour &col)
| Sets the colour of the item's text.
void | SetQuickBestSize (bool quickBestSize)
| If true is passed, specifies that the control will use a quick calculation for the best size, looking only at the first and last items.
virtual void | SetStateImageList (wxImageList *imageList)
| Sets the state image list (from which application-defined state images are taken).
void | SetWindowStyle (long styles)
| Sets the mode flags associated with the display of the tree control.
virtual void | SortChildren (const wxTreeItemId &item)
| Sorts the children of the given item using OnCompareItems().
virtual void | Toggle (const wxTreeItemId &item)
| Toggles the given item between collapsed and expanded states.
void | ToggleItemSelection (const wxTreeItemId &item)
| Toggles the given item between selected and unselected states.
virtual void | Unselect ()
| Removes the selection from the currently selected item (if any).
virtual void | UnselectAll ()
| This function either behaves the same as Unselect() if the control doesn't have `wxTR_MULTIPLE` style, or removes the selection from all items if it does have this style.
void | UnselectItem (const wxTreeItemId &item)
| Unselects the given item.
virtual void | SelectChildren (const wxTreeItemId &parent)
| Select all the immediate children of the given parent.
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control.
| wxControl ()
| Default constructor to allow 2-phase creation.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item.
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel().
wxString | GetLabelText () const
| Returns the control's label without mnemonics.
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text.
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetLabel (const wxString &label)
| Sets the control's label.
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string.
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup.
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor.
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window.
virtual | ~wxWindow ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus.
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard.
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus.
bool | IsFocusable () const
| Can this window itself have focus?
bool | CanAcceptFocus () const
| Can this window have focus right now?
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now?
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus.
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0).
virtual void | SetFocus ()
| This sets the window to receive keyboard input.
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g.
virtual void | AddChild (wxWindow *child)
| Adds a child window.
bool | DestroyChildren ()
| Destroys all children of a window.
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id.
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name.
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children.
const wxWindowList & | GetChildren () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | RemoveChild (wxWindow *child)
| Removes a child window.
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one.
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child.
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent.
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `` NULL if this window is the first child.
bool | IsDescendant (wxWindowBase *win) const
| Check if the specified window is a descendant of this one.
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g.
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling.
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position.
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range.
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size.
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation.
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation.
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown.
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up.
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up.
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly.
bool | LineUp ()
| Same as ScrollLines (-1).
bool | LineDown ()
| Same as ScrollLines (1).
bool | PageUp ()
| Same as ScrollPages (-1).
bool | PageDown ()
| Same as ScrollPages (1).
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars.
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar.
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows.
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once.
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value.
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size.
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size.
virtual void | Fit ()
| Sizes the window so that it fits around its subwindows.
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window.
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window.
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width.
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height.
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels.
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result.
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area.
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window.
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area.
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size.
int | GetMinWidth () const
| Returns the horizontal component of window minimal size.
int | GetMinHeight () const
| Returns the vertical component of window minimal size.
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size.
int | GetMaxHeight () const
| Returns the vertical component of window maximal size.
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc.
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info.
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels.
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead.
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means)
virtual double | GetContentScaleFactor () const
| Returns the magnification of the backing store of this window, eg 2.0 for a window on a retina screen.
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively.
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known.
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed.
void | PostSizeEvent ()
| Posts a size event to the window.
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window.
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions.
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent().
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels.
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetContainingSizer (wxSizer *sizer)
| This normally does not need to be called by user code.
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values.
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area.
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size.
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area.
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size.
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels.
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels.
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged.
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels.
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | Center (int dir=wxBOTH)
| A synonym for Centre().
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent().
void | Centre (int direction=wxBOTH)
| Centres the window.
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent.
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object.
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object.
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...)
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates.
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | SetPosition (const wxPoint &pt)
| A synonym for Centre().
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels.
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units.
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates.
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates.
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour.
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all.
void | Thaw ()
| Re-enables window updating after a previous call to Freeze().
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze().
wxColour | GetBackgroundColour () const
| Returns the background colour of the window.
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window.
virtual int | GetCharHeight () const
| Returns the character height for this window.
virtual int | GetCharWidth () const
| Returns the average character width for this window.
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()).
wxFont | GetFont () const
| Returns the font for this window.
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window.
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged.
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords.
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background.
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted.
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted.
virtual void | Update ()
| Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop).
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window.
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window.
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work.
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window.
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window.
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window.
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent.
bool | UseBgCol () const
| Return true if a background colour has been set for this window.
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window.
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window.
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes().
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code.
virtual bool | GetThemeEnabled () const
| Clears the window by filling it with the current background colour.
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed.
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window.
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window.
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case.
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for:
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent().
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally().
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack.
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window.
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack.
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window.
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
long | GetExtraStyle () const
| Returns the extra style bits for the window.
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method.
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info.
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles.
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set.
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window.
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window.
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info.
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa.
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win.
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it.
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window.
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window.
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order).
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order).
bool | Hide ()
| Equivalent to calling wxWindow::Show(false).
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible.
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise.
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint.
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden.
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well.
bool | Disable ()
| Disables the window.
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input.
virtual bool | Show (bool show=true)
| Shows or hides the window.
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible.
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window.
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window.
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window.
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none.
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none.
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window.
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | UnsetToolTip ()
| Unset any existing tooltip.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu.
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxValidator * | GetValidator ()
| Validator functions.
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type.
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators.
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators.
virtual bool | Validate ()
| Validates the current values of the child controls using their validators.
wxWindowID | GetId () const
| Returns the identifier of the window.
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported.
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32.
virtual wxString | GetName () const
| Returns the window's name.
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant().
void | SetId (wxWindowID winid)
| Sets the identifier of the window.
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window.
virtual void | SetName (const wxString &name)
| Sets the window's name.
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use.
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window.
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any.
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window.
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window.
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window.
virtual bool | Destroy ()
| Destroys the window safely.
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed.
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL.
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window.
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles).
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL.
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL.
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer.
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| This method calls SetSizer() and then wxSizer::SetSizeHints which sets the initial window size to the size needed to accommodate all sizer elements and sets the size hints which, if this window is a top level one, prevent the user from resizing it to be less than this minimal size.
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none.
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints.
virtual bool | Layout ()
| Invokes the constraint-based layout algorithm or the sizer-based algorithm for this window.
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized.
bool | GetAutoLayout () const
| Returns the sizer of which this window is a member, if any, otherwise NULL.
void | CaptureMouse ()
| Directs all mouse input to this window.
wxCaret * | GetCaret () const
| Returns the caret() associated with the window.
const wxCursor & | GetCursor () const
| Return the cursor associated with this window.
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture.
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse().
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window.
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor.
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window.
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxHitTest | HitTest (const wxPoint &pt) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxBorder | GetBorder () const
| Get border for the flags of this window.
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event.
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window.
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages.
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours.
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators.
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later.
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it.
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise.
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called.
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one.
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class.
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows.
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey.
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey.
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window.
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor.
virtual | ~wxEvtHandler ()
| Destructor.
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method.
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor.
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it.
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process.
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail.
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent().
virtual bool | SearchEventTable (wxEventTable &table, wxEvent &event)
| Searches the event table, executing an event handler function if an appropriate one is found.
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type.
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event.
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
void * | GetClientData () const
| Returns user-supplied client data.
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object.
void | SetClientData (void *data)
| Sets user-supplied client data.
void | SetClientObject (wxClientData *data)
| Set the client data object.
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise.
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain.
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain.
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler.
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted).
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Additional Inherited Members
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters).
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters).
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string.
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.
Protected Member Functions inherited from wxWindow
virtual void | DoCentre (int direction)
| Centres the window.
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden.
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control.
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation.
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation.
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord).
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window.
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself.
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | QueueEvent (wxEvent *event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | AddPendingEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
void | ProcessPendingEvents ()
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
bool | ProcessThreadEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

wxTreeCtrl::wxTreeCtrl | ( |  | ) |

Default Constructor.

wxTreeCtrl::wxTreeCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTR_DEFAULT_STYLE`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxTreeCtrlNameStr`
| ) |  |

Constructor, creating and showing a tree control.

Parameters

  parent | Parent window. Must not be NULL.
  id | Window identifier. The value `wxID_ANY` indicates a default value.
  pos | Window position. If wxDefaultPosition is specified then a default position is chosen.
  size | Window size. If wxDefaultSize is specified then the window is sized appropriately.
  style | Window style. See wxTreeCtrl.
  validator | Window validator.
  name | Window name.

See Also
  Create(), wxValidator

virtual wxTreeCtrl::~wxTreeCtrl | ( |  | ) |
| virtual

Destructor, destroying the tree control.

## Member Function Documentation

virtual wxTreeItemId wxTreeCtrl::AddRoot | ( | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL`
| ) |  |
| virtual

Adds the root node to the tree, returning the new item.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

wxTreeItemId wxTreeCtrl::AppendItem | ( | const wxTreeItemId & | parent,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL`
| ) |  |

Appends an item to the end of the branch identified by parent, return a new item id.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image > -1 and selImage is -1, the same image is used for both selected and unselected items.

void wxTreeCtrl::AssignButtonsImageList | ( | wxImageList * | imageList | ) |

Sets the buttons image list.

The button images assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

Setting or assigning the button image list enables the display of image buttons. Once enabled, the only way to disable the display of button images is to set the button image list to NULL.

This function is only available in the generic version.

See Also
  SetButtonsImageList().

void wxTreeCtrl::AssignImageList | ( | wxImageList * | imageList | ) |

Sets the normal image list.

The image list assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

See Also
  SetImageList().

void wxTreeCtrl::AssignStateImageList | ( | wxImageList * | imageList | ) |

Sets the state image list.

Image list assigned with this method will be automatically deleted by wxTreeCtrl as appropriate (i.e. it takes ownership of the list).

See Also
  SetStateImageList().

virtual void wxTreeCtrl::ClearFocusedItem | ( |  | ) |
| virtual

Clears the currently focused item.

Since
  2.9.1

virtual void wxTreeCtrl::Collapse | ( | const wxTreeItemId & | item | ) |
| virtual

Collapses the given item.

void wxTreeCtrl::CollapseAll | ( |  | ) |

Collapses the root item.

See Also
  ExpandAll()

void wxTreeCtrl::CollapseAllChildren | ( | const wxTreeItemId & | item | ) |

Collapses this item and all of its children, recursively.

See Also
  ExpandAllChildren()

virtual void wxTreeCtrl::CollapseAndReset | ( | const wxTreeItemId & | item | ) |
| virtual

Collapses the given item and removes all children.

bool wxTreeCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTR_DEFAULT_STYLE`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxTreeCtrlNameStr`
| ) |  |

Creates the tree control.

See wxTreeCtrl::wxTreeCtrl() for further details.

virtual void wxTreeCtrl::Delete | ( | const wxTreeItemId & | item | ) |
| virtual

Deletes the specified item.

A `EVT_TREE_DELETE_ITEM` event will be generated.

This function may cause a subsequent call to GetNextChild() to fail.

virtual void wxTreeCtrl::DeleteAllItems | ( |  | ) |
| virtual

Deletes all items in the control.

Note that this may not generate `EVT_TREE_DELETE_ITEM` events under some Windows versions although normally such event is generated for each removed item.

virtual void wxTreeCtrl::DeleteChildren | ( | const wxTreeItemId & | item | ) |
| virtual

Deletes all children of the given item (but not the item itself).

Note that this will not generate any events unlike Delete() method.

If you have called SetItemHasChildren(), you may need to call it again since DeleteChildren() does not automatically clear the setting.

virtual wxTextCtrl* wxTreeCtrl::EditLabel | ( | const wxTreeItemId & | item,
|  | wxClassInfo * | textCtrlClass = `wxCLASSINFO(wxTextCtrl)`
| ) |  |
| virtual

Starts editing the label of the given item.

This function generates a `EVT_TREE_BEGIN_LABEL_EDIT` event which can be vetoed so that no text control will appear for in-place editing.

If the user changed the label (i.e. s/he does not press ESC or leave the text control without changes, a `EVT_TREE_END_LABEL_EDIT` event will be sent which can be vetoed as well.

See Also
  EndEditLabel(), wxTreeEvent

void wxTreeCtrl::EnableBellOnNoMatch | ( | bool | on = `true` | ) |

Enable or disable a beep if there is no match for the currently entered text when searching for the item from keyboard.

The default is to not beep in this case except in wxMSW where the beep is always generated by the native control and cannot be disabled, i.e. calls to this function do nothing there.

Since
  2.9.5

virtual void wxTreeCtrl::EndEditLabel | ( | const wxTreeItemId & | item,
|  | bool | discardChanges = `false`
| ) |  |
| virtual

Ends label editing.

If cancelEdit is true, the edit will be cancelled.

Note
  This function is currently supported under Windows only.

See Also
  EditLabel()

virtual void wxTreeCtrl::EnsureVisible | ( | const wxTreeItemId & | item | ) |
| virtual

Scrolls and/or expands items to ensure that the given item is visible.

virtual void wxTreeCtrl::Expand | ( | const wxTreeItemId & | item | ) |
| virtual

Expands the given item.

void wxTreeCtrl::ExpandAll | ( |  | ) |

Expands all items in the tree.

void wxTreeCtrl::ExpandAllChildren | ( | const wxTreeItemId & | item | ) |

Expands the given item and all its children recursively.

virtual bool wxTreeCtrl::GetBoundingRect | ( | const wxTreeItemId & | item,
|  | wxRect & | rect,
|  | bool | textOnly = `false`
| ) |  | const
| virtual

Retrieves the rectangle bounding the item.

If textOnly is true, only the rectangle around the item's label will be returned, otherwise the item's image is also taken into account.

The return value is true if the rectangle was successfully retrieved or `` false if it was not (in this case rect is not changed) – for example, if the item is currently invisible.

Notice that the rectangle coordinates are logical, not physical ones. So, for example, the x coordinate may be negative if the tree has a horizontal scrollbar and its position is not 0.

wxPerl Note: In wxPerl this method only takes the item and textOnly parameters and returns a `Wx::Rect` (or `undef`).

wxImageList* wxTreeCtrl::GetButtonsImageList | ( |  | ) | const

Returns the buttons image list (from which application-defined button images are taken).

This function is only available in the generic version.

virtual size_t wxTreeCtrl::GetChildrenCount | ( | const wxTreeItemId & | item,
|  | bool | recursively = `true`
| ) |  | const
| virtual

Returns the number of items in the branch.

If recursively is true, returns the total number of descendants, otherwise only one level of children is counted.

virtual unsigned int wxTreeCtrl::GetCount | ( |  | ) | const
| virtual

Returns the number of items in the control.

virtual wxTextCtrl* wxTreeCtrl::GetEditControl | ( |  | ) | const
| virtual

Returns the edit control being currently used to edit a label.

Returns NULL if no label is being edited.

Note
  This is currently only implemented for wxMSW.

virtual wxTreeItemId wxTreeCtrl::GetFirstChild | ( | const wxTreeItemId & | item,
|  | wxTreeItemIdValue & | cookie
| ) |  | const
| virtual

Returns the first child; call GetNextChild() for the next child.

For this enumeration function you must pass in a 'cookie' parameter which is opaque for the application but is necessary for the library to make these functions reentrant (i.e. allow more than one enumeration on one and the same object simultaneously). The cookie passed to GetFirstChild() and GetNextChild() should be the same variable.

Returns an invalid tree item (i.e. wxTreeItemId::IsOk() returns false) if there are no further children.

wxPerl Note: In wxPerl this method only takes the item parameter, and returns a 2-element list (item, cookie).

See Also
  GetNextChild(), GetNextSibling()

virtual wxTreeItemId wxTreeCtrl::GetFirstVisibleItem | ( |  | ) | const
| virtual

Returns the first visible item.

virtual wxTreeItemId wxTreeCtrl::GetFocusedItem | ( |  | ) | const
| virtual

Returns the item last clicked or otherwise selected.

Unlike GetSelection(), it can be used whether or not the control has the `wxTR_MULTIPLE` style.

Since
  2.9.1

wxImageList* wxTreeCtrl::GetImageList | ( |  | ) | const

Returns the normal image list.

virtual unsigned int wxTreeCtrl::GetIndent | ( |  | ) | const
| virtual

Returns the current tree control indentation.

virtual wxColour wxTreeCtrl::GetItemBackgroundColour | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the background colour of the item.

virtual wxTreeItemData* wxTreeCtrl::GetItemData | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the tree item data associated with the item.

See Also
  wxTreeItemData

wxPerl Note: wxPerl provides the following shortcut method:

- GetPlData(item): returns the Perl data associated with the Wx::TreeItemData. It is just the same as tree->GetItemData(item)->GetData().

virtual wxFont wxTreeCtrl::GetItemFont | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the font of the item label.

If the font hadn't been explicitly set for the specified item with SetItemFont(), returns an invalid wxNullFont font. GetFont() can be used to retrieve the global tree control font used for the items without any specific font.

virtual int wxTreeCtrl::GetItemImage | ( | const wxTreeItemId & | item,
|  | wxTreeItemIcon | which = `wxTreeItemIcon_Normal`
| ) |  | const
| virtual

Gets the specified item image.

The value of which may be:

- wxTreeItemIcon_Normal: to get the normal item image.
- wxTreeItemIcon_Selected: to get the selected item image (i.e. the image which is shown when the item is currently selected).
- wxTreeItemIcon_Expanded: to get the expanded image (this only makes sense for items which have children - then this image is shown when the item is expanded and the normal image is shown when it is collapsed).
- wxTreeItemIcon_SelectedExpanded: to get the selected expanded image (which is shown when an expanded item is currently selected).

virtual wxTreeItemId wxTreeCtrl::GetItemParent | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the item's parent.

int wxTreeCtrl::GetItemState | ( | const wxTreeItemId & | item | ) | const

Gets the specified item state.

virtual wxString wxTreeCtrl::GetItemText | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the item label.

virtual wxColour wxTreeCtrl::GetItemTextColour | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the colour of the item label.

virtual wxTreeItemId wxTreeCtrl::GetLastChild | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the last child of the item (or an invalid tree item if this item has no children).

See Also
  GetFirstChild(), GetNextSibling(), GetLastChild()

virtual wxTreeItemId wxTreeCtrl::GetNextChild | ( | const wxTreeItemId & | item,
|  | wxTreeItemIdValue & | cookie
| ) |  | const
| virtual

Returns the next child; call GetFirstChild() for the first child.

For this enumeration function you must pass in a 'cookie' parameter which is opaque for the application but is necessary for the library to make these functions reentrant (i.e. allow more than one enumeration on one and the same object simultaneously). The cookie passed to GetFirstChild() and GetNextChild() should be the same.

Returns an invalid tree item if there are no further children.

wxPerl Note: In wxPerl this method returns a 2-element list (item, cookie) instead of modifying its parameters.

See Also
  GetFirstChild()

virtual wxTreeItemId wxTreeCtrl::GetNextSibling | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the next sibling of the specified item; call GetPrevSibling() for the previous sibling.

Returns an invalid tree item if there are no further siblings.

See Also
  GetPrevSibling()

virtual wxTreeItemId wxTreeCtrl::GetNextVisible | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the next visible item or an invalid item if this item is the last visible one.

Note
  The item itself must be visible.

virtual wxTreeItemId wxTreeCtrl::GetPrevSibling | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the previous sibling of the specified item; call GetNextSibling() for the next sibling.

Returns an invalid tree item if there are no further children.

See Also
  GetNextSibling()

virtual wxTreeItemId wxTreeCtrl::GetPrevVisible | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns the previous visible item or an invalid item if this item is the first visible one.

Note
  The item itself must be visible.

bool wxTreeCtrl::GetQuickBestSize | ( |  | ) | const

Returns true if the control will use a quick calculation for the best size, looking only at the first and last items.

The default is false.

See Also
  SetQuickBestSize()

virtual wxTreeItemId wxTreeCtrl::GetRootItem | ( |  | ) | const
| virtual

Returns the root item for the tree control.

virtual wxTreeItemId wxTreeCtrl::GetSelection | ( |  | ) | const
| virtual

Returns the selection, or an invalid item if there is no selection.

This function only works with the controls without `wxTR_MULTIPLE` style, use GetSelections() for the controls which do have this style or, if a single item is wanted, use GetFocusedItem().

virtual size_t wxTreeCtrl::GetSelections | ( | wxArrayTreeItemIds & | selection | ) | const
| virtual

Fills the array of tree items passed in with the currently selected items.

This function can be called only if the control has the `wxTR_MULTIPLE` style.

Returns the number of selected items.

wxPerl Note: In wxPerl this method takes no parameters and returns a list of `Wx::TreeItemId`.

wxImageList* wxTreeCtrl::GetStateImageList | ( |  | ) | const

Returns the state image list (from which application-defined state images are taken).

wxTreeItemId wxTreeCtrl::HitTest | ( | const wxPoint & | point,
|  | int & | flags
| ) |  | const

Calculates which (if any) item is under the given point, returning the tree item id at this point plus extra information flags.

flags is a bitlist of the following:

- `wxTREE_HITTEST_ABOVE:` Above the client area.
- `wxTREE_HITTEST_BELOW:` Below the client area.
- `wxTREE_HITTEST_NOWHERE:` In the client area but below the last item.
- `wxTREE_HITTEST_ONITEMBUTTON:` On the button associated with an item.
- `wxTREE_HITTEST_ONITEMICON:` On the bitmap associated with an item.
- `wxTREE_HITTEST_ONITEMINDENT:` In the indentation associated with an item.
- `wxTREE_HITTEST_ONITEMLABEL:` On the label (string) associated with an item.
- `wxTREE_HITTEST_ONITEMRIGHT:` In the area to the right of an item.
- `wxTREE_HITTEST_ONITEMSTATEICON:` On the state icon for a tree view item that is in a user-defined state.
- `wxTREE_HITTEST_TOLEFT:` To the right of the client area.
- `wxTREE_HITTEST_TORIGHT:` To the left of the client area.

wxPerl Note: In wxPerl this method only takes the point parameter and returns a 2-element list (item, flags).

wxTreeItemId wxTreeCtrl::InsertItem | ( | const wxTreeItemId & | parent,
|  | const wxTreeItemId & | previous,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL`
| ) |  |

Inserts an item after a given one (previous).

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

wxTreeItemId wxTreeCtrl::InsertItem | ( | const wxTreeItemId & | parent,
|  | size_t | pos,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL`
| ) |  |

Inserts an item before one identified by its position (pos).

pos must be less than or equal to the number of children.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

virtual bool wxTreeCtrl::IsBold | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns true if the given item is in bold state.

See Also
  SetItemBold()

bool wxTreeCtrl::IsEmpty | ( |  | ) | const

Returns true if the control is empty (i.e. has no items, even no root one).

virtual bool wxTreeCtrl::IsExpanded | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns true if the item is expanded (only makes sense if it has children).

virtual bool wxTreeCtrl::IsSelected | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns true if the item is selected.

virtual bool wxTreeCtrl::IsVisible | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns true if the item is visible on the screen.

virtual bool wxTreeCtrl::ItemHasChildren | ( | const wxTreeItemId & | item | ) | const
| virtual

Returns true if the item has children.

virtual int wxTreeCtrl::OnCompareItems | ( | const wxTreeItemId & | item1,
|  | const wxTreeItemId & | item2
| ) |  |
| virtual

Override this function in the derived class to change the sort order of the items in the tree control.

The function should return a negative, zero or positive value if the first item is less than, equal to or greater than the second one.

Please note that you must use wxRTTI macros wxDECLARE_DYNAMIC_CLASS() and wxIMPLEMENT_DYNAMIC_CLASS() if you override this function because otherwise the base class considers that it is not overridden and uses the default comparison, i.e. sorts the items alphabetically, which allows it optimize away the calls to the virtual function completely.

See Also
  SortChildren()

wxTreeItemId wxTreeCtrl::PrependItem | ( | const wxTreeItemId & | parent,
|  | const wxString & | text,
|  | int | image = `-1`,
|  | int | selImage = `-1`,
|  | wxTreeItemData * | data = `NULL`
| ) |  |

Appends an item as the first child of parent, return a new item id.

The image and selImage parameters are an index within the normal image list specifying the image to use for unselected and selected items, respectively. If image -1 and selImage is -1, the same image is used for both selected and unselected items.

virtual void wxTreeCtrl::ScrollTo | ( | const wxTreeItemId & | item | ) |
| virtual

Scrolls the specified item into view.

virtual void wxTreeCtrl::SelectChildren | ( | const wxTreeItemId & | parent | ) |
| virtual

Select all the immediate children of the given parent.

This function can be used with multiselection controls only.

Since
  2.9.1

virtual void wxTreeCtrl::SelectItem | ( | const wxTreeItemId & | item,
|  | bool | select = `true`
| ) |  |
| virtual

Selects the given item.

In multiple selection controls, can be also used to deselect a currently selected item if the value of select is false.

Notice that calling this method will generate `wxEVT_TREE_SEL_CHANGING` and `wxEVT_TREE_SEL_CHANGED` events and that the change could be vetoed by the former event handler.

void wxTreeCtrl::SetButtonsImageList | ( | wxImageList * | imageList | ) |

Sets the buttons image list (from which application-defined button images are taken).

The button images assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself. Setting or assigning the button image list enables the display of image buttons. Once enabled, the only way to disable the display of button images is to set the button image list to NULL.

Note
  This function is only available in the generic version.

See Also
  AssignButtonsImageList().

virtual void wxTreeCtrl::SetFocusedItem | ( | const wxTreeItemId & | item | ) |
| virtual

Sets the currently focused item.

Parameters

  item | The item to make the current one. It must be valid.

Since
  2.9.1

virtual void wxTreeCtrl::SetImageList | ( | wxImageList * | imageList | ) |
| virtual

Sets the normal image list.

The image list assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself.

See Also
  AssignImageList().

virtual void wxTreeCtrl::SetIndent | ( | unsigned int | indent | ) |
| virtual

Sets the indentation for the tree control.

virtual void wxTreeCtrl::SetItemBackgroundColour | ( | const wxTreeItemId & | item,
|  | const wxColour & | col
| ) |  |
| virtual

Sets the colour of the item's background.

virtual void wxTreeCtrl::SetItemBold | ( | const wxTreeItemId & | item,
|  | bool | bold = `true`
| ) |  |
| virtual

Makes item appear in bold font if bold parameter is true or resets it to the normal state.

See Also
  IsBold()

virtual void wxTreeCtrl::SetItemData | ( | const wxTreeItemId & | item,
|  | wxTreeItemData * | data
| ) |  |
| virtual

Sets the item client data.

Notice that the client data previously associated with the item (if any) is not freed by this function and so calling this function multiple times for the same item will result in memory leaks unless you delete the old item data pointer yourself.

wxPerl Note: wxPerl provides the following shortcut method:

- SetPlData(item, data): sets the Perl data associated with the `Wx::TreeItemData`. It is just the same as tree->GetItemData(item)->SetData(data).

virtual void wxTreeCtrl::SetItemDropHighlight | ( | const wxTreeItemId & | item,
|  | bool | highlight = `true`
| ) |  |
| virtual

Gives the item the visual feedback for Drag'n'Drop actions, which is useful if something is dragged from the outside onto the tree control (as opposed to a DnD operation within the tree control, which already is implemented internally).

virtual void wxTreeCtrl::SetItemFont | ( | const wxTreeItemId & | item,
|  | const wxFont & | font
| ) |  |
| virtual

Sets the item's font.

All items in the tree should have the same height to avoid text clipping, so the fonts height should be the same for all of them, although font attributes may vary.

See Also
  SetItemBold()

virtual void wxTreeCtrl::SetItemHasChildren | ( | const wxTreeItemId & | item,
|  | bool | hasChildren = `true`
| ) |  |
| virtual

Force appearance of the button next to the item.

This is useful to allow the user to expand the items which don't have any children now, but instead adding them only when needed, thus minimizing memory usage and loading time.

virtual void wxTreeCtrl::SetItemImage | ( | const wxTreeItemId & | item,
|  | int | image,
|  | wxTreeItemIcon | which = `wxTreeItemIcon_Normal`
| ) |  |
| virtual

Sets the specified item's image.

See GetItemImage() for the description of the which parameter.

void wxTreeCtrl::SetItemState | ( | const wxTreeItemId & | item,
|  | int | state
| ) |  |

Sets the specified item state.

The value of state may be:

- `wxTREE_ITEMSTATE_NONE:` to disable the item state (the state image will be not displayed).
- `wxTREE_ITEMSTATE_NEXT:` to set the next item state.
- `wxTREE_ITEMSTATE_PREV:` to set the previous item state.

virtual void wxTreeCtrl::SetItemText | ( | const wxTreeItemId & | item,
|  | const wxString & | text
| ) |  |
| virtual

Sets the item label.

virtual void wxTreeCtrl::SetItemTextColour | ( | const wxTreeItemId & | item,
|  | const wxColour & | col
| ) |  |
| virtual

Sets the colour of the item's text.

void wxTreeCtrl::SetQuickBestSize | ( | bool | quickBestSize | ) |

If true is passed, specifies that the control will use a quick calculation for the best size, looking only at the first and last items.

Otherwise, it will look at all items. The default is false.

See Also
  GetQuickBestSize()

virtual void wxTreeCtrl::SetStateImageList | ( | wxImageList * | imageList | ) |
| virtual

Sets the state image list (from which application-defined state images are taken).

Image list assigned with this method will not be deleted by wxTreeCtrl's destructor, you must delete it yourself.

See Also
  AssignStateImageList().

void wxTreeCtrl::SetWindowStyle | ( | long | styles | ) |

Sets the mode flags associated with the display of the tree control.

The new mode takes effect immediately.

Note
  Generic only; MSW ignores changes.

virtual void wxTreeCtrl::SortChildren | ( | const wxTreeItemId & | item | ) |
| virtual

Sorts the children of the given item using OnCompareItems().

You should override that method to change the sort order (the default is ascending case-sensitive alphabetical order).

See Also
  wxTreeItemData, OnCompareItems()

virtual void wxTreeCtrl::Toggle | ( | const wxTreeItemId & | item | ) |
| virtual

Toggles the given item between collapsed and expanded states.

void wxTreeCtrl::ToggleItemSelection | ( | const wxTreeItemId & | item | ) |

Toggles the given item between selected and unselected states.

For multiselection controls only.

virtual void wxTreeCtrl::Unselect | ( |  | ) |
| virtual

Removes the selection from the currently selected item (if any).

virtual void wxTreeCtrl::UnselectAll | ( |  | ) |
| virtual

This function either behaves the same as Unselect() if the control doesn't have `wxTR_MULTIPLE` style, or removes the selection from all items if it does have this style.

void wxTreeCtrl::UnselectItem | ( | const wxTreeItemId & | item | ) |

Unselects the given item.

This works in multiselection controls only.